'******************************************************************************
' ARP declarations (IP required)
'******************************************************************************
'*******************************************************************************
'  Pollin NET-IO Board with Atmega32 / 644 / 644P and ENC28J60
'*******************************************************************************
'
'  Copyright bascom-forum.de (C) [2009]  [DON]
'  -> http://bascom-forum.de/index.php?topic=1781.new;topicseen#new
'  Software based on Code by Ben Zijlstra and Viktor Varga
'  Weiterentwickelt von
'    Huetti,
'    Michael
'    boeserkorn
'    mr_energy
'    HansHans
'    six1, Michael Kcher
'    dabuze                            datetime
'    framuel
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile                                                  'will compile only as an include file

'******************************************************************************
' ARP Frame
'******************************************************************************
Dim Arp_w_hwtype As Word At Buffer(15) Overlay
Dim Arp_w_prottype As Word At Buffer(17) Overlay
Dim Arp_b_hwlen As Byte At Buffer(19) Overlay
Dim Arp_b_protlen As Byte At Buffer(20) Overlay
Dim Arp_w_op As Word At Buffer(21) Overlay
Dim Arp_b_src_mac(6) As Byte At Buffer(23) Overlay
Dim Arp_b_src_ip(4) As Byte At Buffer(29) Overlay
Dim Arp_b_dest_mac(6) As Byte At Buffer(33) Overlay
Dim Arp_b_dest_ip(4) As Byte At Buffer(39) Overlay
Dim Arp_b_dest_ip_l As Long At Buffer(39) Overlay

'******************************************************************************
' Variables
'******************************************************************************
Const Arp_packet_length = 42
Const Arp_w_hwtype_ethernet = &H0100                        'reversed 0001 = Ethernet
Const Arp_w_prottype_ipv4 = &H0008                          'reversed 0800 = IP Version4
Const Arp_w_op_request = &H0100                             'reversed 0001 = Request
Const Arp_w_op_reply = &H0200                               'reversed 0002 = Reply
Const Arp_cache_size = 10
Const Arp_cache_ttl_default = 15                            'Minuten!
Const Arp_cache_ttl_used = 24                               'Minuten!
Const Arp_cache_ttl_expired = 0                             'Minuten!

'ARP Cache
Dim Arp_cache_mac1(arp_cache_size) As Byte
Dim Arp_cache_mac2(arp_cache_size) As Byte
Dim Arp_cache_mac3(arp_cache_size) As Byte
Dim Arp_cache_mac4(arp_cache_size) As Byte
Dim Arp_cache_mac5(arp_cache_size) As Byte
Dim Arp_cache_mac6(arp_cache_size) As Byte
Dim Arp_cache_ip1(arp_cache_size) As Byte
Dim Arp_cache_ip2(arp_cache_size) As Byte
Dim Arp_cache_ip3(arp_cache_size) As Byte
Dim Arp_cache_ip4(arp_cache_size) As Byte
Dim Arp_cache_ttl(arp_cache_size) As Byte
Dim Arp_cache_pointer As Byte

'Dim Arp_cache_oldest As Byte

'Dim Arp_b_lookup_ip(4) As Byte

'******************************************************************************
' Subroutines
'******************************************************************************
'(
*** z.Z. noch in Entwicklung bzw. Test ***
*** endgltige Dokumentation erfolgt spter ***
')'
Declare Sub Arp_first_init
'( Aufruf aus: NETIO.bas
   Holt Wichtige Mac Adressen Nach Dem Neustart
')
Declare Sub Arp_packet_filter
'( Aufruf aus: Ip_packet_filter
   Pakete , Die Nicht Die Eigene Ip Adresse Betreffen , Werden Verworfen.
   Anschlieend Wird In Die Routinen Arp_request_received Bzw. Arp_reply_received Verzweigt
')
Declare Sub Arp_every_minute
'( Aufruf aus dem Hauptprogramm
   Diese Routine Sollte Aus Dem Hauptprogramm Heraus Etwa 1 X Pro Minute Aufgerufen Werden.
   Dient Zur Verwaltung Des Arp Caches.
')
Declare Sub Arp_send_request
'(
   Es Wird Ein Apr Request Paket Aufgebaut Und Verschickt
')
Declare Sub Arp_request_received
'(
   Der Arp Request Wird Einfach Mit Einem Arp Rreply Beantwortet
')
Declare Sub Arp_send_reply
'(
   Es Wird Ein Apr Reply Paket Aufgebaut Und Verschickt
')
Declare Sub Arp_reply_received
'(
   Die Daten Aus Dem Arp Reply Werden In Den Arp Cache Eingetragen
')

Declare Sub Arp_dump_frame
'( Aufruf bei Bedarf
   Der Arp Frame Wird In Lesbarer Form ber Die Serielle Schnittstelle Ausgegeben.
')
Declare Sub Arp_enqueue_ip(ip_addr As Byte)
'(
   Folgt
')
Declare Function Arp_request_destmac_for_ip(ip_addr As Byte) As Byte
'(
   Folgt
')
Declare Sub Arp_cache_lookup(ip_addr As Byte)
'(
   Der Arp Cache Wird Nach Der bergebenen Ip Adresse Durchsucht
')
Declare Sub Arp_cache_lookup_oldest()
'(
   Der Arp Cache Wird Nach Dem ltesten Eintrag Durchsucht
')
Declare Sub Arp_cache_mark_used(cacheptr As Byte)
'(
   Der Cache -eintrag Wird Als Ungltig Markiert.
')
Declare Sub Arp_cache_decrement_ttl
'(
   Die Ttl Werte Der Cache -eintrge Werden Heruntergezhlt.
   Bei Erreichen Eines Schwellwertes Wird Vorsorglich Ein Neuer Arp Request Ausgelst,
   Beim Erreichen Von 0 Zhlt Der Cache Eintrag Als Ungltig
')
Declare Sub Arp_cache_insert_reply
'(
   Die Empfangenen Daten Werden In Den Cache Eingetragen.
')
#if Debug_arp > 0
Declare Sub Arp_dump_cache
'(
  Der Arp Cache Wird ber Die Serielle Schnittstelle Ausgegeben.
')
'
#endif